"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xstream_1 = require("xstream");
var fromEvent_1 = require("xstream/extra/fromEvent");
exports.VueCycleDomDirective = {
    bind: function (el, binding, vnode) {
        if (typeof (binding.value) === 'undefined') {
            throw new Error('VueCycle expects directive value to be defined');
        }
        var _a = typeof (binding.value) === 'string'
            ? ({ name: binding.value, data: null })
            : binding.value, sourceName = _a.name, data = _a.data;
        if (!binding.arg) {
            throw new Error('VueCycle expects an event name in directive argument');
        }
        var eventName = binding.arg;
        if (!el.$_dom_source_data) {
            el.$_dom_source_data = {};
        }
        if (!el.$_dom_source_unbind_callback) {
            el.$_dom_source_unbind_callback = {};
        }
        if (!vnode.context.$_dom_source[sourceName]) {
            vnode.context.$_dom_source[sourceName] = [];
        }
        el.$_dom_source_data[eventName] = data;
        var source$ = xstream_1.default.create({
            start: function (listener) {
                var event$ = null;
                if (!binding.modifiers.native && vnode.componentInstance) {
                    if (vnode.componentInstance.$fromCustomEvent) {
                        event$ = vnode.componentInstance.$fromCustomEvent(eventName);
                    }
                    else {
                    }
                }
                else {
                    event$ = fromEvent_1.default(el, eventName);
                }
                event$.addListener({
                    next: function (event) {
                        listener.next({
                            event: event,
                            data: el.$_dom_source_data[eventName]
                        });
                    }
                });
            },
            stop: function () {
                delete el.$_dom_source_data[sourceName];
            }
        });
        vnode.context.$_dom_source[sourceName].push(source$);
    },
    update: function (el, binding) {
        if (typeof (binding.value) !== 'string') {
            el.$_dom_source_data[binding.arg] = binding.value.data;
        }
    }
};
//# sourceMappingURL=dom.js.map