"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var xstream_1 = require("xstream");
var adapt_1 = require("@cycle/run/lib/adapt");
exports.VueCycleDOMMixin = {
    created: function () {
        var _this = this;
        if (!this.$_dom_source) {
            this.$_dom_source = {};
        }
        this.$domDriver = function () {
            return {
                on: function (eventName) {
                    var dom$ = xstream_1.default.create({
                        start: function (listener) {
                            if (_this.$_dom_source[eventName]) {
                                var _loop_1 = function (i) {
                                    var source$ = _this.$_dom_source[eventName][i];
                                    source$.addListener({
                                        next: function (data) {
                                            listener.next(data);
                                        },
                                        complete: function () {
                                            delete _this.$_dom_source[eventName][i];
                                        }
                                    });
                                };
                                for (var i = 0; i < _this.$_dom_source[eventName].length; i++) {
                                    _loop_1(i);
                                }
                            }
                            _this.$_dom_source[eventName] = {
                                push: function (source$) {
                                    source$.addListener({
                                        next: function (data) {
                                            listener.next(data);
                                        }
                                    });
                                }
                            };
                        },
                        stop: function () {
                        }
                    });
                    return adapt_1.adapt(dom$);
                }
            };
        };
    }
};
//# sourceMappingURL=dom.js.map